package com.dgtly.order.mapper;


import com.dgtly.order.domain.MetaHanaSalesOrder;
import org.apache.ibatis.annotations.MapKey;

import java.util.List;
import java.util.Map;

/**
 * <p>
 *  Mapper 接口
 * </p>
 *
 * @author csz
 * @since 2020-07-30
 */
public interface MetaHanaSalesOrderMapper  {

    List<MetaHanaSalesOrder> selectDistinctMetaHanaSalesOrder(MetaHanaSalesOrder metaHanaSalesOrder);

    @MapKey("order_number")
    Map<String,Map<String,Object>> selectOrderExcepTimeByList(List<String> orderNumbers);

    List<MetaHanaSalesOrder> selectDistinctMetaHanaSalesOrder1(MetaHanaSalesOrder metaHanaSalesOrder);

}
