package com.dgtly.sync.mapper;

import com.dgtly.sync.domain.MetaEmployeeDiy;
import com.dgtly.sync.domain.MetaEmployee;
import java.util.List;

/**
 * MetaEmployeeMapperMapper接口
 * 
 * @author dgtly
 * @date 2023-07-05
 */
public interface MetaEmployeeMapper
{
    /**
     * 查询MetaEmployeeMapper
     * 
     * @param name MetaEmployeeMapperID
     * @return MetaEmployeeMapper
     */
    public MetaEmployee selectMetaEmployeeDiyCopy1ById(String name);

    /**
     * 查询MetaEmployeeMapper列表
     * 
     * @param
     * @return MetaEmployeeMapper集合
     */
    public List<MetaEmployee> selectMetaEmployeeDiyCopy1List(MetaEmployee metaEmployee);





    /**
     * @description: 直接查零售下事业部人员
     * @param:
     * @return:
     * @author: njs
     * @date: 2023/7/5 16:28
     */
    public List<MetaEmployee> selectMetaEmployeeDiyListByDivision();

    /**
     * 查询立邦雇员数据同步列表
     *线索报备
     * @param
     * @return 立邦雇员数据同步集合
     */
    public List<MetaEmployee> selectMetaEmployeetClueReporting();

}
