package com.dgtly.sync.service;

import com.dgtly.sync.domain.SyncLog;

public interface IAnalysisSysUserService {

    /**
     * 解析部门数据
     * @param packageId
     * @return
     */
    public SyncLog analysisSysUser(String packageId);

    /**
     * @description: 解析零售下事业部人员
     * @param:
     * @return:
     * @author: njs
     * @date: 2023/5/10 10:12
     */
    public SyncLog analysisSysDivisionUser();

    /**
     * 解析厨卫部门数据
     * @param packageId
     * @return
     */
    /*public SyncLog analysisSysCwUser(String packageId);*/
    
    /**
     * @description: 解析雅士利部门数据
     * @param: [packageId]
     * @return: com.dgtly.sync.domain.SyncLog
     * @author: lhy      
     * @date: 2022/4/18 11:05
     */ 
    public SyncLog analysisSysYSLUser(String packageId);
    /**
     * @description: 解析除ysl,diy,cw外用户数据
     * @param: [packageId]
     * @return: com.dgtly.sync.domain.SyncLog
     * @author: njs
     * @date: 2022/5/13 9:00
     */
    public SyncLog analysisSysClueReporting();
}
