package com.dgtly.system.service.impl;

import com.dgtly.system.mapper.HanaSalesOrderMapper;
import com.dgtly.system.service.HanaSalesOrderService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class HanaSalesOrderServiceImpl implements HanaSalesOrderService {

    @Autowired
    private HanaSalesOrderMapper hanaSalesOrderMapper;
    /**
     * @description: 未过信的经销商订单的要货记录id（做逻辑删除，重新要货）
     * @param: []
     * @return: void
     * @author: njs
     * @date: 2023/6/16 14:35
     */
    @Override
    public void updateSalesOrderBaseNoCrditStatus() {
        List<String> orderBaseList = hanaSalesOrderMapper.selectOrderBaseList();
        if(orderBaseList !=null && orderBaseList.size()>0){
            hanaSalesOrderMapper.deleteLogic(orderBaseList);
        }
    }
}
