package com.dgtly.order.mapper;

import com.dgtly.order.domain.EvaluateDto;

import java.util.List;

/**
 * 交货单基础Mapper接口
 * 
 * @author dgtly
 * @date 2020-11-12
 */
public interface EvaluateMapper
{
    /**
     * 查询交货单基础
     * 
     * @param id 交货单基础ID
     * @return 交货单基础
     */
    EvaluateDto selectEvaluateDtoById(Long id);

    /**
     * 查询交货单基础列表
     * 
     * @param deliverOrderBase 交货单基础
     * @return 交货单基础集合
     */
    List<EvaluateDto> selectEvaluateDtoList(EvaluateDto deliverOrderBase);
}
