package com.dgtly.order.service;

import com.dgtly.order.domain.EvaluateDto;

import java.util.List;

/**
 * 评价管理service
 */
public interface EvaluateService {
    /**
     * 查询交货单基础
     *
     * @param id 交货单基础ID
     * @return 交货单基础
     */
    public EvaluateDto selectEvaluateDtoById(Long id);

    /**
     * 查询交货单基础列表
     *
     * @param deliverOrderBase 交货单基础
     * @return 交货单基础集合
     */
    public List<EvaluateDto> selectEvaluateDtoList(EvaluateDto deliverOrderBase);

}
