package com.dgtly.order.service;


import com.dgtly.order.domain.SalesOrderBase;

import java.util.List;

/**
 * 订单基础 Service接口
 * 
 * @author dgtly
 * @date 2023-05-23
 */
public interface ISalesOrderBaseService 
{
    /**
     * 查询订单基础 
     * 
     * @param id 订单基础 ID
     * @return 订单基础 
     */
    public SalesOrderBase selectSalesOrderBaseById(Long id);

    /**
     * 查询订单基础 列表
     * 
     * @param salesOrderBase 订单基础 
     * @return 订单基础 集合
     */
    public List<SalesOrderBase> selectSalesOrderBaseList(SalesOrderBase salesOrderBase);

}
