package com.dgtly.sync.service;

import com.dgtly.sync.domain.MetaEmployee;
import com.dgtly.sync.domain.MetaEmployeeDiy;
import java.util.List;

/**
 * 立邦雇员数据同步Service接口
 * 
 * @author qxp
 * @date 2020-07-28
 */
public interface IMetaEmployeeDiyService {
    /**
     * 查询立邦雇员数据同步
     *
     * @param name 立邦雇员数据同步ID
     * @return 立邦雇员数据同步
     */
    public MetaEmployee selectMetaEmployeeDiyById(String name);

    /**
     * 查询立邦雇员数据同步列表
     *
     * @param
     * @return 立邦雇员数据同步集合
     */
    public List<MetaEmployee> selectMetaEmployeeDiyList(MetaEmployee metaEmployee);


}

