package com.dgtly.sync.service.impl;

import java.util.List;

import com.dgtly.sync.domain.MetaEmployee;
import com.dgtly.sync.mapper.MetaEmployeeMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import com.dgtly.sync.domain.MetaEmployeeDiy;
import com.dgtly.sync.service.IMetaEmployeeDiyService;
import com.dgtly.common.core.text.Convert;

/**
 * 立邦雇员数据同步Service业务层处理
 * 
 * @author qxp
 * @date 2020-07-28
 */
@Service
public class MetaEmployeeDiyServiceImpl implements IMetaEmployeeDiyService 
{
    @Autowired
    private MetaEmployeeMapper metaEmployeeDiyMapper;

    /**
     * 查询立邦雇员数据同步
     * 
     * @param name 立邦雇员数据同步ID
     * @return 立邦雇员数据同步
     */
    @Override
    public MetaEmployee selectMetaEmployeeDiyById(String name)
    {
        return metaEmployeeDiyMapper.selectMetaEmployeeDiyCopy1ById(name);
    }

    /**
     * 查询立邦雇员数据同步列表
     * 
     * @param
     * @return 立邦雇员数据同步
     */
    @Override
    public List<MetaEmployee> selectMetaEmployeeDiyList(MetaEmployee metaEmployee)
    {
        return metaEmployeeDiyMapper.selectMetaEmployeeDiyCopy1List(metaEmployee);
    }







}
