package com.dgtly.system.domain;

import com.dgtly.common.annotation.Excel;
import com.dgtly.common.annotation.Excel.ColumnType;
import com.dgtly.common.annotation.Excel.Type;
import com.dgtly.common.annotation.Excels;
import com.dgtly.common.core.domain.BaseEntity;
import com.dgtly.common.core.domain.Ztree;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;
import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;

import javax.validation.constraints.Email;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.Size;
import java.util.Date;
import java.util.List;

/**
 * 用户重复对象 VO
 * 
 *
 */
@Data
public class UserVO
{
    private static final long serialVersionUID = 1L;


    /** 登录名称 */
    @Excel(name = "登录名称")
    private String loginName;

    /** 用户名称 */
    @Excel(name = "用户名称")
    private String userName;

    /** 手机号码 */
    @Excel(name = "手机号码")
    private String phonenumber;


}
